---
title: PublicKeyCredential
slug: Web/API/PublicKeyCredential
tags:
  - API
  - Authentication
  - Interface
  - PublicKeyCredential
  - Reference
  - Web Authentication API
  - WebAuthn
---
<div>{{APIRef("Web Authentication API")}}{{securecontext_header}}</div>

<p>The <code><strong>PublicKeyCredential</strong></code> interface provides information about a public key / private key pair, which is a credential for logging in to a service using an un-phishable and data-breach resistant asymmetric key pair instead of a password. It inherits from {{domxref("Credential")}}, and was created by the <a href="/en-US/docs/Web/API/Web_Authentication_API">Web Authentication API</a> extension to the <a href="/en-US/docs/Web/API/Credential_Management_API">Credential Management API</a>. Other interfaces that inherit from {{domxref("Credential")}} are {{domxref("PasswordCredential")}} and {{domxref("FederatedCredential")}}.</p>

<div class="note">
<p><strong>Note:</strong> This API is restricted to top-level contexts. Use from within an {{HTMLElement("iframe")}} element will not have any effect.</p>
</div>

<h2 id="Properties">Properties</h2>

<dl>
 <dt><code>PublicKeyCredential.type</code> {{ReadOnlyInline()}}{{securecontext_inline}}</dt>
 <dd>Inherited from {{domxref("Credential")}}. Always set to <code>public-key</code> for <code>PublicKeyCredential</code> instances.</dd>
 <dt>{{domxref("PublicKeyCredential.id")}} {{ReadOnlyInline()}}{{securecontext_inline}}</dt>
 <dd>Inherited from {{domxref("Credential")}} and overridden to be the <a href="/en-US/docs/Web/API/WindowBase64/Base64_encoding_and_decoding">base64url encoding</a> of {{domxref("PublicKeyCredential.rawId")}}.</dd>
 <dt>{{domxref("PublicKeyCredential.rawId")}} {{ReadOnlyInline()}}{{securecontext_inline}}</dt>
 <dd>An {{domxref("ArrayBuffer")}} that holds the globally unique identifier for this <code>PublicKeyCredential</code>. This identifier can be used to look up credentials for future calls to {{domxref("CredentialsContainer.get")}}.</dd>
 <dt>{{domxref("PublicKeyCredential.response")}} {{ReadOnlyInline()}} {{securecontext_inline}}</dt>
 <dd>An instance of an {{domxref("AuthenticatorResponse")}} object. It is either of type {{domxref("AuthenticatorAttestationResponse")}} if the <code>PublicKeyCredential</code> was the results of a {{domxref("CredentialsContainer.create()","navigator.credentials.create()")}} call, or of type {{domxref("AuthenticatorAssertionResponse")}} if the <code>PublicKeyCredential</code> was the result of a {{domxref("CredentialsContainer.get()","navigator.credentials.get()")}} call.</dd>
</dl>

<h2 id="Methods">Methods</h2>

<dl>
 <dt>{{domxref("PublicKeyCredential.getClientExtensionResults()")}}{{securecontext_inline}}</dt>
 <dd>If any extensions were requested, this method will return the results of processing those extensions.</dd>
 <dt>{{domxref("PublicKeyCredential.isUserVerifyingPlatformAuthenticatorAvailable()")}}{{securecontext_inline}}</dt>
 <dd>A static method returning a {{jsxref("Promise")}} which resolves to <code>true</code> if an authenticator bound to the platform is capable of <em>verifying</em> the user. With the current state of implementation, this method only resolves to <code>true</code> when <a href="https://docs.microsoft.com/en-us/microsoft-edge/dev-guide/windows-integration/web-authentication">Windows Hello</a> is available on the system.</dd>
</dl>

<h2 id="Examples">Examples</h2>

<h3 id="Creating_a_new_instance_of_PublicKeyCredential">Creating a new instance of PublicKeyCredential</h3>

<p>Here, we use {{domxref("CredentialsContainer.create()","navigator.credentials.create()")}} to generate a new credential.</p>

<pre class="brush: js">var publicKey = {
  challenge: /* from the server */,
  rp: {
    name: "Example CORP",
    id  : "login.example.com"
  },
  user: {
    id: new Uint8Array(16),
    name: "jdoe@example.com",
    displayName: "John Doe"
  },
  pubKeyCredParams: [
    {
      type: "public-key",
      alg: -7
    }
  ]
};

navigator.credentials.create({ publicKey })
  .then(function (newCredentialInfo) {
    var response = newCredentialInfo.response;
    var clientExtensionsResults = newCredentialInfo.getClientExtensionResults();
  }).catch(function (err) {
     console.error(err);
  });</pre>

<h3 id="Getting_an_existing_instance_of_PublicKeyCredential">Getting an existing instance of PublicKeyCredential</h3>

<p>Here, we fetch an existing credential from an authenticator, using {{domxref("CredentialsContainer.get()","navigator.credentials.get()")}}.</p>

<pre class="brush: js">var options = {
  challenge: new Uint8Array([/* bytes sent from the server */])
};

navigator.credentials.get({ "publicKey": options })
    .then(function (credentialInfoAssertion) {
    // send assertion response back to the server
    // to proceed with the control of the credential
}).catch(function (err) {
     console.error(err);
});

</pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td>{{SpecName('WebAuthn','#iface-pkcredential','PublicKeyCredential interface')}}</td>
   <td>{{Spec2('WebAuthn')}}</td>
   <td>Initial definition.</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("api.PublicKeyCredential")}}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li>The parent interface {{domxref("Credential")}}</li>
</ul>
